"""
"""
__author__ = "Kjartan A Jonsson"
__version__ = "$Revision: 1.9 $"
__copyright__ = "Copyright (c) 2007 aGameCompany"
__license__ = "aGameCompany"
import sys
sys.path.append ("..\\..\\..\\scripts\\MachineRace") #add the path to game script
sys.path.append ("..\\..\\..\\scripts\\MachineRace\\modules") #add the path to game script
###################################################################################
import const
import __core as core
import MachineManager
#must load here so modules are global
import SystemHandler
import GUI
import menu
import authenticate
import settings #for building machine
import xmlrpclib#for building machine

class MachineRaceOnline (SystemHandler.GameBase) :
    _modules_ = {}
    module_names = ["rover", "ir", "gps", "radio"] #camera
    player_profile = {}
    player_control = [] #control devices used by player, can be usr, remote or ai
    player_machine = [] #machines the player controls (using player_controls)
    time = 0
    def keyCallback (self, bKeyDown, strKey) : 
        """
        The function called when the user presses or releases keyboard buttons after the key is registered through keyEnabled(...).
        When bKeyDown equals false then the user released the button. strKey is the string representation of the key in question.        
        * Will broadcast to all modules    
        """
        menu.keyboard_callback (bKeyDown, strKey)
        #forward only to an controller
        for control in self.player_control : control.callback (const.CONTROL_CALLBACK_KEYBOARD, {"key":strKey, "down":bKeyDown})
        if bKeyDown and strKey == 'HOME' :
            print "Reloading scripts ..............."
            for control in self.player_control : 
                control.reload()
                print "Reloading script ... "+str(control)+" loaded"


    def resourceCallback(self) : 
        """
        This callback will be called every time the system loads or unloads something (note must be notified by the system to turn up here).
        """
        pass
    def systemCallback (self, trap, message) : 
        """
        This callback will be called every time the system wants to say something. Messages expected are:
        Event 10 means that we are loading something. Message is formated as a dictionary {'name':'Page_0_1', 'precent':51.32}
        Event 11 means that we are unloading something. Message is formated as a dictionary {'name':'Page_0_1', 'precent':21}        
        * Will broadcast to all modules    
        """
        for module in self._modules_ :
            if self._modules_[module] <> None :
                self._modules_[module].callback (0, 0, message)
                
    def timerCallback (self, trap, message) : 
        """
        The function called when a user requested a callback through funciton timerCallBack(...).
        trap is the trap id sent through the timerCallBack call and message is the associated string.        
        * Will broadcast to all modules    
        """
        #forward also to an controller
        if trap == const.MENU_CALLBACK_TIMER :
            self.receaveEvent(trap, message)
        if trap == 999 : #modules callback, expects a dictionary
            for module in self._modules_ :
                if self._modules_[module] <> None :
                    self._modules_[module].callback (999, 0, message)
        elif trap == 11001 :# and message == "READY" :
            self.player_profile = authenticate.data["profile"]
            core.module_entity_loader(self.player_profile)
            self.player_control = core.module_entity_control(self.player_profile)
        elif trap == const.CONTROL_CALLBACK_TIMER : 
            self.time = self.time + const.CALLBACK_TIME_AI
            SystemHandler.timerCallBack(const.CALLBACK_TIME_AI, const.CONTROL_CALLBACK_TIMER, str({})) #prepare for next callback
            for control in self.player_control : 
                control.callback (trap, message)
                control.setTime (self.time)
                        
    def networkCallback (self, trap, message) : 
        """
        The function called when the system gets network package from an external resource. Is enabled after a call to networkConnect(...).
        Event is an id (not used) and data is the a string that was receaved.        
        * Will broadcast to all modules    
        """
        dic = eval(message)["keys"]
        dic["machines"] = MachineManager.getMachineProfile ( dic["account_key"] )
        dic.update(dic["machines"])
        try : 
            core.module_machine_loader (dic, False)
        except Exception, e : 
            print "Network call-back: Could not load all machines. Got " + str(e)
    
    def intersectionCallback (self, objectName, event, collisions) : 
        """
        objectName is the name of the entity who detected the instersection. event is
        what actully happened and sourceTargetTuple is an array of all the objects that
        are currently intersecting this movable object. 
        For instance is may get this movableObjectName -> robot_1, status -> Intersecting, 
        sourceStateTuple -> ["robot_2","true"] for an intersecting robot_2 intersecting with
        robot_1.    
        * Will broadcast to all modules    
        """ 
        #check for the driver owner
        machines = MachineManager.getMachines()
        sensors = core.getSensorOwners()
        #for m in machines :
        if sensors.has_key(objectName) :
            machinename = sensors[objectName]["machine"]
            devicename  = sensors[objectName]["device"]
            if not machines.has_key(machinename) : #skip it if it does not exist since it may be a other users device 
                return None #print "ERROR the machine '"+machinename+"' does not exist in " + str(machines.keys())
            try :
                if not machines[machinename].hasDevice (devicename) : 
                    print "ERROR the device does not exist '" + devicename + "' for machine " + machinename + "' machine has '" + str(machines[machinename].getDevices().keys()) + "'"
                dev = machines[machinename].getDevice(devicename)
            except Exception : pass #print "ERROR the device could not be retreaved '" + devicename + "' for machine " + machinename + "'"
            if dev.machine_group == "sensor" :
                dev._addIntersection (objectName, collisions)
                    
    def receaveMenuEvent (self, source, event, message): 
        """
        * Will broadcast to all modules    
        """
        for control in self.player_control : control.receaveEvent (source, event, message)
        menu.callback(source, event, message)

    def receaveEvent (self, event, message): 
        """Will broadcast to all modules """
        if event == const.MENU_CALLBACK_TIMER :        
            menu.callback(None, event, message)
    
    def setup (self) :
        import time
        self.time = time.time()
        menu.create()
        SystemHandler.keyEnabled( "HOME", True )
        SystemHandler.keyEnabled( "ESCAPE", True )
        SystemHandler.timerCallBack(const.CALLBACK_TIME_AI, const.CONTROL_CALLBACK_TIMER, str({}))
        
    def destroy (self) :
        for module in self._modules_ :
            if self._modules_[module] <> None :
                self._modules_[module].destroy ()
