"""
"""
__author__ = "Kjartan A Jonsson"
__version__ = "$Revision: 1.20 $"
__copyright__ = "Copyright (c) 2007 aGameCompany"
__license__ = "aGameCompany"


import PhysicsManager 
import SceneManager
import SystemHandler
import xmlrpclib
import const

import settings
    
import __vehiclemanager as vehiclemanager
import __devicemanager as devicemanager

import MachineManager

import random
import ir
import rover
import camera
import gps
import radio
import footing
import weapon

from MachineRaceOnline import MachineRaceOnline

__sensor_owners = {}

def getSensorOwners () : return __sensor_owners

class BaseDevice :
    entity = None
    body = None
    def __init__ (self, group=None):
        self.machine_group = group
    def addIgnore (self, item): pass

def __build_rocks (profile):
    """
    Builds up the world
    """
    #__rpc_minerals = xmlrpclib.ServerProxy( settings.SERV_WORLD_MINERAL, transport=settings.proxy  )
    #rocks = __rpc_minerals.getRocks( )
    rocks = settings.cache ("rocks")	
    if rocks == None : raise Exception, "Could not get the rocks from server"
    #{'pose': {'position': [-450.0, None, -392.0], 'rotation': [0.93527663385699999, 0.0, 0.0, 0.0]}, 'name:': 'bedrock_91e4acb6d37c8713a38e61de4e518d86', 'material': 'stone_red', 'mesh': 'cube.1m.mesh', 'scale': [0.50951925147999999, 4.2279874201599998, 0.62937702296200004], 'type': 1}
    index = 0
    for id in rocks : 
        index = index  + 1
        rock = rocks[id]
        pose = rock["pose"]
        pose["position"][1] = 0
        mass = 10 #todo: calculate based on scale of object and material type
        static = True
        if rock["type"] == 1 : static = True
        p = PhysicsManager.addMesh(id, rock["mesh"], mass, pose["position"], static)#, rock["scale"])
        p.setOrientation(pose["rotation"][0], pose["rotation"][1], pose["rotation"][2], pose["rotation"][3])
        #np = pose["position"]
        np = p.getPosition()
        e = SceneManager.addEntity ("wall"+id, rock["mesh"])#(id+"msh", rock["mesh"])
        pose = rock["pose"]
        e.setOrientation(pose["rotation"][0], pose["rotation"][1], pose["rotation"][2], pose["rotation"][3])
        #e.setScale(rock["scale"][0]*0.8, rock["scale"][1]*0.8, rock["scale"][2]*0.8)
        e.setPosition(np[0], np[1], np[2])
        e.setVisible (True)
        #e.showBoundingbox()
        
def __machine_poses (profile):
    #__rpc_machnines = xmlrpclib.ServerProxy( settings.SERV_WORLD_STATE, transport=settings.proxy )
    #machines = __rpc_machnines.getMachines(profile["controler_key"])
    machines = settings.cache ("machines")
    if machines == None : 
        raise Exception, "Could not get the machines from server"
    return machines 

def __build_device_container (machinename, devicename, setup, isowner):
    import container
    pose = setup["pose"]    
    mesh = setup["blueprint"]["mesh"]
    #create a mesh
    #e = PhysicsManager.addBox(devicename, mesh) 
    e = SceneManager.addEntity(devicename, mesh)
    #place it
    p = pose["position"]
    o = pose["rotation"]
    e.setPosition(p[0],p[1],p[2])
    e.setOrientation(o[0],o[1],o[2],o[3])
    #make intersection enabled
    if isowner :
        container_device = container.Device(e)
    else : container_device = BaseDevice()
    container_device.entity = e #container_device 
    container_device.body = None #container_device
    return container_device

def __build_device_ir (machinename, devicename, setup, isowner):
    pose = setup["pose"]    
    mesh = setup["blueprint"]["mesh"]
    #create a mesh
    #irdevphys = PhysicsManager.addBox(devicename, mesh) 
    irdevphys = SceneManager.addEntity(devicename, mesh)
    irdev = irdevphys #.getEntity()
    p = pose["position"]
    o = pose["rotation"]
    irdev.setPosition(p[0], p[1], p[2])
    irdev.setOrientation(o[0], o[1], o[2], o[3])
    irdev.setVisible(True)
    #         0 door     1 front left 2 front      3 front     4 front right 5 door      back 6      back 7
    irpos = [[1.5,0,0], [1.6,0,2.4], [0.4,0,2.6],[-0.4,0,2.6],[-1.6,0,2.4], [-1.5,0,0],[-0.5,0,-2.3],[0.5,0,-2.3]]
    irrot = [90, 45, 0,0, -45,  -90, 45,  -45]
    irscl = [[1,1,1], [1,1,0.8], [1,1,1],[1,1,1], [1,1,0.8],  [1,1,1], [1,1,1],  [1,1,1]]
    toignore = []
    if isowner :
        for i in range(0,len(irpos)) :
            sensor = SceneManager.addEntity(devicename+"_ir_"+str(i), mesh)
            s = irscl[i]
            sensor.setScale(0.4*s[0], 0.4*s[1], 2.5*s[2])
            o = irrot[i]
            sensor.setYaw (o)                
            irdev.attach(sensor)
            p  = irpos[i]
            sensor.setPosition(p[0],p[1],p[2])
            sensor.setVisible(False)
            SystemHandler.addIntersectionDetection(sensor.id)
            __sensor_owners[sensor.id] = {}
            __sensor_owners[sensor.id]["device"] = devicename
            __sensor_owners[sensor.id]["machine"] = machinename
            toignore.append(sensor.id) #ignore owns sensors
    irdev.setVisible(False, True)
    #make intersection enabled
    if isowner :
        irdevice = ir.Device(irdev)
    else : irdevice = BaseDevice ("sensor")
    irdevphys.setVisible(False)
    irdevice.entity = irdevphys
    irdevice.body = None
    for ownsensor in toignore : irdevice.addIgnore(ownsensor)
    #load all the child device poses
    return irdevice

def __build_device_camera (machinename, devicename, setup, isowner):
    """Cameras are always oriented streight and reversed"""
    pose = setup["pose"]
    mesh = setup["blueprint"]["mesh"]  
    #create a mesh
    #cameradev = PhysicsManager.addBox(devicename, mesh) 
    cameradev = SceneManager.addEntity(devicename, mesh)
    p = pose["position"]
    o = pose["rotation"]
    cameradev.setPosition (p[0], p[1], p[2])
    cameradev.setOrientation (o[0],o[1],o[2],o[3]) #cameras are always oriented streight and reversed
    if isowner : 
        cameradevice = camera.Device(cameradev, machinename)
    else : cameradevice = BaseDevice ()
    cameradevice.setVisible(False)
    cameradevice.entity = cameradev
    cameradevice.body = None
    return cameradevice

def __build_device_gps (machinename, devicename, setup, isowner):
    pose = setup["pose"]
    mesh = setup["blueprint"]["mesh"]  
    #create a mesh
    #gpsdev = PhysicsManager.addBox(devicename, mesh) 
    gpsdev = SceneManager.addEntity(devicename, mesh)
    p = pose["position"]
    o = pose["rotation"]
    gpsdev.setPosition (p[0], p[1], p[2])
    gpsdev.setOrientation(o[0], o[1], o[2], o[3])
    if isowner :
        GPSdevice = gps.Device(gpsdev)
    else : GPSdevice = BaseDevice()
    gpsdev.setVisible(False)
    GPSdevice.entity = gpsdev
    GPSdevice.body = None
    return GPSdevice

def __build_device_radio (machinename, devicename, setup, isowner):
    pose = setup["pose"]
    mesh = setup["blueprint"]["mesh"]  
    #create a mesh
    body = None #PhysicsManager.addBox(devicename, mesh)
    entity = SceneManager.addEntity(devicename, mesh)
    p = pose["position"]
    entity.setPosition (p[0], p[1]+0.8, p[2])
    entity.setOrientation(0,0,1,0)
    if isowner : 
        device = radio.Device(entity, machinename)
    else : device = BaseDevice ()
    entity.setVisible(False)
    device.entity = entity
    device.body = body
    return device

def __build_device_vehicle (machinename, devicename, pose, profile, isowner):
    __KEYBOARD_DEFAULT_STATE = {"Gas":str( False ).lower(), "Brake":str( False ).lower(), "Left":str( False ).lower(), "Right":str( False ).lower()}
    v = vehiclemanager.getDynamicVehicle (profile["account_key"], devicename, machinename)#devicename, profile[machinename]["session"])
    PhysicsManager.setCar ( machinename, __KEYBOARD_DEFAULT_STATE ) #( profile[machinename]["session"], __KEYBOARD_DEFAULT_STATE )
    pose = {"position":[-434,20,-600], "rotation":[1,0,0,0]}
    p = pose["position"]
    o = pose["rotation"]
    v.setPosition (p[0],2,p[2])
    v.setOrientation (o[0],o[1],o[2],o[3])
    device_target_entity = v
    if isowner : 
        device = rover.Device(v)
    else : device = BaseDevice("vehicle")
    device.entity = SceneManager.Entity(v.getPartName("chassi")[0]) #device_target_entity
    device.body = v
    return device    

def __build_device_footing (machinename, devicename, setup, isowner):
    pose = setup["pose"]
    mesh_base = setup["blueprint"]["mesh"]  
    mesh_upper = setup["blueprint"]["mesh"]  
    #create a mesh
    physbase = PhysicsManager.addMesh(devicename+"_physical_footer", mesh_base, 10000, pose["position"], True)
    p = pose["position"]
    if isowner :
        device = footing.Device(physbase)
    else : device = BaseDevice ("footing")
    device.entity = physbase.getEntity()
    device.body = physbase
    return device

def __build_device_weapon (machinename, devicename, setup, isowner):
    pose = setup["pose"]
    mesh = setup["blueprint"]["mesh"]
    force = setup["blueprint"]["force"]
    range = setup["blueprint"]["range"]
    mass = setup["blueprint"]["mass"]
    blazon = setup["blueprint"]["blazon"]
    #create a weapon
    if blazon == "gravity" :
        weaponinst = PhysicsManager.addMagnetTool(devicename+"_physical_weapon_magnet", mesh, force, range, mass, [0,0,0])
    elif blazon == "firearm" :
        weaponinst = PhysicsManager.addGunTool(devicename+"_physical_weapon_firearm", mesh, force, range, mass, [0,0,0])
    elif blazon == "rocket" :
        weaponinst = PhysicsManager.addRocketTool(devicename+"_physical_weapon_rocket", mesh, force, range, mass, [0,0,0])
    entity_base = weaponinst
    p = pose["position"]
    if isowner : 
        device = weapon.Device(entity_base)
    else : device = BaseDevice ()
    device.entity = entity_base.getEntity()
    device.body = entity_base
    return device

def _build_machine (machine, profile, name, devices, device_target_body, device_target_entity, isowner):
        machinename = profile["controler_key"]+name
        for group in devices : #where group is {'type':'base', 'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': '4x2 Terrain Rover x1.2', 'class': 'vehicle', 'devices':devices_body}
            pose = group["pose"]
            devicename = group["name"]
            device_class = group["class"]
            devname = machinename+"_"+devicename
            if device_class == "ir" :
                dev = __build_device_ir(machinename, devname, group, isowner)
                machine.addDevice(devname, dev)
                if device_target_entity == None : raise Exception, "Could not attach "+device_class+" to machine " + machinename + " because the base must be a entity. Got None"
                device_target_entity.attach(dev.entity, group["pose"]["position"])
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)
            if device_class == "vehicle" : 
                dev = __build_device_vehicle (name, group["name"], group["pose"], profile, isowner) #use device instead of devicename in this case
                machine.addDevice(group["name"], dev)
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)
            if device_class == "container" :
                dev = __build_device_container(machinename, name, group, isowner)
                machine.addDevice(devname, dev)
                if device_target_entity == None : raise Exception, "Could not attach "+device_class+" to machine " + machinename + " because the base must be a entity. Got None"
                device_target_entity.attach(dev.entity, group["pose"]["position"])
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)
            if device_class == "footing" :
                dev = __build_device_footing(machinename, name, group, isowner)
                machine.addDevice(devname, dev)
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)                
            if device_class == "camera" :
                dev = __build_device_camera(machinename, devname, group, isowner)
                machine.addDevice(devname, dev)
                if device_target_entity == None : raise Exception, "Could not attach "+device_class+" to machine " + machinename + " because the base must be a entity. Got None"
                device_target_entity.attach(dev.entity, group["pose"]["position"])
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)
            if device_class == "gps" : 
                dev = __build_device_gps(machinename, devname, group, isowner)
                machine.addDevice(devname, dev)
                if device_target_entity == None : raise Exception, "Could not attach "+device_class+" to machine " + machinename + " because the base must be a entity. Got None"
                device_target_entity.attach(dev.entity, group["pose"]["position"])
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)
            if device_class == "radio" : 
                dev = __build_device_radio(machinename, devname, group, isowner)
                machine.addDevice(devname, dev)
                if device_target_entity == None : raise Exception, "Could not attach "+device_class+" to machine " + machinename + " because the base must be a entity. Got None"
                device_target_entity.attach(dev.entity, group["pose"]["position"])
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)
            if device_class == "weapon" :
                dev = __build_device_weapon(machinename, devname, group, isowner)
                machine.addDevice(devname, dev)
                if device_target_body == None : raise Exception, "Could not attach "+device_class+" to machine " + machinename + " because the base must be a body. Got None"
                device_target_body.attach(dev.body, group["pose"]["position"])
                _build_machine (machine, profile, name, group["devices"], dev.body, dev.entity, isowner)

def module_machine_loader (profile, isowner) :
    machines_poses = __machine_poses (profile)
    machines_setup = profile["machines"]
    for name in machines_setup :
        profilename = profile["controler_key"]+name
        #machinename = machines_poses[profilename]["session"]
        machinename = profile["controler_key"]+name
        if machines_poses.has_key(profilename) : pose = machines_poses[profilename]
        else : pose = {"position":[-434,20,-600], "rotation":[1,0,0,0]}        
        profile[name]["devices"][0]["pose"]["position"] = pose["position"] #update the base device pose (often a vehicle pose
        profile[name]["devices"][0]["pose"]["rotation"] = pose["rotation"]
        profile[name]["session"] = machinename 
        print "Building machine " + str(name) + " at " + str(pose["position"])
        print "----------> ", str(profile)
        machine = MachineManager.Machine ()
        devices = machines_setup[name]["devices"]
        _build_machine(machine, profile, name, devices, None, None, isowner)
        MachineManager.add(machinename, machine, name, isowner)

def module_entity_loader (profile) :
    __build_rocks (profile) #create rocks
    __build_debug_world ()
    module_machine_loader (profile, True)
        
from control import ControlAIPyro        
def module_entity_control (profile):
    player_control = [] #control devices used by player, can be usr, remote or ai
    machines_setup = profile["machines"]
    for name in machines_setup :
        machinename = profile["controler_key"]+name #profile[name]["session"]#build the local machine instance name; account_key + machine name
        c = ControlAIPyro() 
        c.setup("UserBrain")
        player_control.append(c)    
        MachineManager.get(machinename).setControl(c)
    return player_control
        
import unittest
class TestBuildMachine(unittest.TestCase):
    
    def setUp(self):
        l = SceneManager.addLight("Sun")
        l.setPosition (10,1000,10)
        #let there be sky
        SceneManager.setSkyBox ("StormySkyBox")
        #load scene
        PhysicsManager.setAreaRegion("landscape.xml")
        PhysicsManager.createWorld("")
        ##Motion debuging
        c = SceneManager.getCamera() #no error should be found, because a noname camera is the default camera
        c.setPosition (0, 0, -10)
        c.setFlyFreeControl()
        ###################################
        # connect to servers so we can get the online machine through vehicle manager
        ###################################
        #profile = {'username': 'unittest', 'first_name': 'Kjartan', 'last_name': u'J\xf3nsson', 'last': '2008-05-11 09:54:22.769000', 'name': u'Kjartan J\xf3nsson', 'contractor_key': 'unittesteg8axQyp96hzrElSsP2tY5dOnRXHiZT10JFCm3I7kujNAVDLMUoK', 'joined': '2008-03-15 12:09:51', 'account_key': 'unittestSBmdEx9hMsgoRqf10Q5DeOyiUPpLZbXJkzu3V8aYFvrG7Il6c2KT', 'alias': 'unittest', 'active': True, 'controler_key': 'unittestB1OaMxSUgrzCvFJD85lVT2XjpHhNPyKbZqcsRGuoE0Lm4dkeA3I6', 'email': 'mail@kjartanjonsson.com', 'machines': {'robbie': {'control': {'type': 'script', 'data': ''}, 'body': {'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'IR 8 1RM', 'class': 'ir'}, 'head': {}, 'base': {'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': '4x2 Terrain Rover x1.2', 'class': 'vehicle'}, 'grip': {}}}, 'staff': False}
        __rpc_state = xmlrpclib.ServerProxy( settings.SERV_STATE_ENTITY, transport=settings.proxy )
        __rpc_world = xmlrpclib.ServerProxy( settings.SERV_WORLD_STATE, transport=settings.proxy )
        self.profile = __rpc_state.login( "unittest", "unittest" )
        profile_world = __rpc_world.login ("unittest", "unittest")        
        __rpc_world.update(self.profile["account_key"], profile_world["controler_key"])
        self.profile["controler_key"] = profile_world["controler_key"]

    def tearDown(self):
        SceneManager.delLight("Sun")
        SceneManager.setSkyBox ("")
        #PhysicsManager.destroyWorld() will crash the client

    def testBuildMachineDefinitionFormat1(self):
        """Core and build machine according to definition format"""
        machine = MachineManager.Machine ()
        pose = {"position":[-0,20,-0], "rotation": [1.0, 0.0, 0.0, 0.0]}
        name = "robbie"
        #create a machine having a base vehicle with a body having IR, Radio and a head where IR has a GPS attached to it
        devices_gps = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [0.0, 0.0, 0.5, 0.0]}, 'name': 'gps', 'class': 'gps', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_radio = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'radio', 'class': 'radio', 'mesh':'cube.1m.mesh', 'devices':[devices_gps]}
        devices_head = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Camera', 'class': 'camera', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_weapon = {'blueprint':{'mesh':'cube.1m.mesh', 'force':11, 'mass':1, 'blazon':'rocket', 'range':21},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'My Weapon', 'class': 'weapon', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_container = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'IR 8 1RM', 'class': 'ir', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_body = [devices_container, devices_radio, devices_head, devices_weapon]
        devices = [{'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': '4x2 Terrain Rover x1.2', 'class': 'vehicle', 'devices': devices_body}] #devices are now a array 
        self.profile["machines"] = {'robbie': {'control': {'type': 'script', 'data': 'UserBrain'}, 'devices':devices}}
        devices = self.profile["machines"][name]['devices']
        machinename = self.profile["controler_key"]+name        
        #build the actual machine with the defined values
        _build_machine (machine, self.profile, name, devices, None, None, True)
        MachineManager.add(machinename, machine, name)

    def testBuildMachineDefinitionFormat1_NoOwner(self):
        """Core and build machine according to definition format"""
        machine = MachineManager.Machine ()
        pose = {"position":[-0,20,-0], "rotation": [1.0, 0.0, 0.0, 0.0]}
        name = "robbie"
        #create a machine having a base vehicle with a body having IR, Radio and a head where IR has a GPS attached to it
        devices_gps = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [0.0, 0.0, 0.5, 0.0]}, 'name': 'gps', 'class': 'gps', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_radio = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'radio', 'class': 'radio', 'mesh':'cube.1m.mesh', 'devices':[devices_gps]}
        devices_head = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Camera', 'class': 'camera', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_weapon = {'blueprint':{'mesh':'cube.1m.mesh', 'force':11, 'mass':1, 'blazon':'rocket', 'range':21},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'My Weapon', 'class': 'weapon', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_container = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'IR 8 1RM', 'class': 'ir', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_body = [devices_container, devices_radio, devices_head, devices_weapon]
        devices = [{'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 5.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': '4x2 Terrain Rover x1.2', 'class': 'vehicle', 'devices': devices_body}] #devices are now a array 
        self.profile["machines"] = {'robbie': {'control': {'type': 'script', 'data': 'UserBrain'}, 'devices':devices}}
        devices = self.profile["machines"][name]['devices']
        machinename = self.profile["controler_key"]+name        
        #build the actual machine with the defined values
        _build_machine (machine, self.profile, name, devices, None, None, False)
        MachineManager.add(machinename, machine, name)


    def testBuildMachineDefinitionFormat2(self):
        """Core and build machine according to definition format creating weaponed tower"""
        machine = MachineManager.Machine ()
        pose = {"position":[-0,20,-0], "rotation": [1.0, 0.0, 0.0, 0.0]}
        name = "Tower inferno"
        #create a machine having a base vehicle with a body having IR, Radio and a head where IR has a GPS attached to it
        devices_gps = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [2.0, 2.0, 0.0], 'rotation': [0.0, 0.0, 0.5, 0.0]}, 'name': 'gps', 'class': 'gps', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_radio = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 1.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'radio', 'class': 'radio', 'mesh':'cube.1m.mesh', 'devices':[devices_gps]}
        devices_head = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 0.0, 2.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Camera', 'class': 'camera', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_container = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Container', 'class': 'container', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_weapon = {'blueprint':{'mesh':'cube.1m.mesh', 'range':1, 'mass':1, 'force':1, 'blazon':'rocket', 'effect':'{}'},'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'My weapon', 'class': 'weapon', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_body = [devices_container, devices_radio, devices_head, devices_weapon]
        devices = [{'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Tower', 'class': 'footing', 'devices':devices_body}] #devices are now a array 
        self.profile["machines"] = {name: {'control': {'type': 'script', 'data': 'UserBrain'}, 'devices':devices}}
        devices = self.profile["machines"][name]['devices']
        machinename = self.profile["controler_key"]+name        
        #build the actual machine with the defined values
        _build_machine (machine, self.profile, name, devices, None, None, True)
        MachineManager.add(machinename, machine, name)
        
    def testBuildMachineDefinitionFormat2_NoOwner(self):
        """Core and build machine according to definition format creating weaponed tower"""
        machine = MachineManager.Machine ()
        pose = {"position":[-0,20,-0], "rotation": [1.0, 0.0, 0.0, 0.0]}
        name = "Tower inferno"
        #create a machine having a base vehicle with a body having IR, Radio and a head where IR has a GPS attached to it
        devices_gps = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [2.0, 2.0, 0.0], 'rotation': [0.0, 0.0, 0.5, 0.0]}, 'name': 'gps', 'class': 'gps', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_radio = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 1.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'radio', 'class': 'radio', 'mesh':'cube.1m.mesh', 'devices':[devices_gps]}
        devices_head = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 0.0, 2.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Camera', 'class': 'camera', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_container = {'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Container', 'class': 'container', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_weapon = {'blueprint':{'mesh':'cube.1m.mesh', 'range':1, 'mass':1, 'force':1, 'blazon':'rocket', 'effect':'{}'},'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'My weapon', 'class': 'weapon', 'mesh':'cube.1m.mesh', 'devices':[]}
        devices_body = [devices_container, devices_radio, devices_head, devices_weapon]
        devices = [{'blueprint':{'mesh':'cube.1m.mesh'},'pose': {'position': [0.0, 0.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'name': 'Tower', 'class': 'footing', 'devices':devices_body}] #devices are now a array 
        self.profile["machines"] = {name: {'control': {'type': 'script', 'data': 'UserBrain'}, 'devices':devices}}
        devices = self.profile["machines"][name]['devices']
        machinename = self.profile["controler_key"]+name        
        #build the actual machine with the defined values
        _build_machine (machine, self.profile, name, devices, None, None, False)
        MachineManager.add(machinename, machine, name)


    def testBuildMachineDefinitionFormat3(self):
        """Core and build machine according to definition format creating tower"""
        machine = MachineManager.Machine ()
        pose = {"position":[-0,20,-0], "rotation": [1.0, 0.0, 0.0, 0.0]}
        name = "Tower inferno"
        self.profile["machines"] = {'Tower inferno': {'devices': [{'blueprint': {'mesh': 'cube.1m.mesh', 'description': 'A big tower', 'motor': '23', 'id': 1}, 'name': 'Tower 3H', 'resource_id': 46, 'pose': {'position': [0.0, 0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [{'blueprint': {'filter': ' ', 'mesh': 'cube.1m.mesh', 'view': ' ', 'description': 'A simple camera having 3 view and 3 filters', 'id': 1}, 'name': 'Camera F3V3', 'resource_id': 47, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 46, 'supports': [{'name': 'Weapon connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 8, 'quaternion_w': 1.0, 'description': 'A basic centered weapon connector'}], 'class': 'camera'}, {'blueprint': {'id': 16, 'mesh': 'cube.1m.mesh', 'locations': '10,50,90,160', 'description': 'Sensor with eight infrared distance sensors.'}, 'name': 'IR 8 1RM', 'resource_id': 48, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 47, 'supports': [{'name': 'Radio connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 3, 'quaternion_w': 1.0, 'description': 'A centered radio connector.'}, {'name': 'GPS connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 5, 'quaternion_w': 1.0, 'description': 'A simple GPS connector'}], 'class': 'ir'}], 'bolt': 45, 'supports': [{'name': 'IR Connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 2, 'quaternion_w': 1.0, 'description': 'A centered connector that allows a base device to add a infrared device.'}, {'name': 'Camera connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 4, 'quaternion_w': 1.0, 'description': 'A simple centered camera connector.'}], 'class': 'footing'}]}, 'robberto': {'devices': [{'blueprint': {'tire_front_id': 4, 'brake_front_id': 6, 'suspension_rear_id': 3, 'driveshaft_front_id': 13, 'id': 15, 'description': 'A 4x2 Terrain Vehicle that ', 'wheel_front_id': 9, 'brake_rear_id': 6, 'chassi_id': 1, 'steering_arm_id': 8, 'axle_front_id': 5, 'shockabsorber_front_id': 10, 'driveshaft_rear_id': 13, 'controlarm_front_id': 12, 'engine_id': 2, 'axle_rear_id': 5, 'tire_rear_id': 4, 'suspension_front_id': 3, 'steering_id': 9, 'shockabsorber_rear_id': 10, 'controlarm_rear_id': 12, 'wheel_rear_id': 9}, 'name': '4x2 Terrain Vehicle x1.2', 'resource_id': 26, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [{'blueprint': {'filter': ' ', 'mesh': 'cube.1m.mesh', 'view': ' ', 'description': 'A simple camera having 3 view and 3 filters', 'id': 1}, 'name': 'Camera F3V3', 'resource_id': 34, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 35, 'supports': [{'name': 'Weapon connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 8, 'quaternion_w': 1.0, 'description': 'A basic centered weapon connector'}], 'class': 'camera'}, {'blueprint': {'id': 16, 'mesh': 'cube.1m.mesh', 'locations': '10,50,90,160', 'description': 'Sensor with eight infrared distance sensors.'}, 'name': 'IR 8 1RM', 'resource_id': 35, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [{'blueprint': {'mesh': 'cube.1m.mesh', 'description': 'Simple radio having three basic services.', 'service': 'request reset;may-day stall', 'id': 1}, 'name': 'Radio S3', 'resource_id': 36, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 37, 'supports': [], 'class': 'radio'}, {'blueprint': {'mesh': 'cube.1m.mesh', 'description': 'Simple GPS system supporting 50 diameter update range.', 'id': 2}, 'name': 'GPS 50D', 'resource_id': 37, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 38, 'supports': [], 'class': 'gps'}], 'bolt': 36, 'supports': [{'name': 'Radio connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 3, 'quaternion_w': 1.0, 'description': 'A centered radio connector.'}, {'name': 'GPS connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 5, 'quaternion_w': 1.0, 'description': 'A simple GPS connector'}], 'class': 'ir'}], 'bolt': 34, 'supports': [{'name': 'IR Connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 2, 'quaternion_w': 1.0, 'description': 'A centered connector that allows a base device to add a infrared device.'}, {'name': 'Camera connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 4, 'quaternion_w': 1.0, 'description': 'A simple centered camera connector.'}], 'class': 'vehicle'}]}}
        devices = self.profile["machines"][name]['devices']
        machinename = self.profile["controler_key"]+name        
        #build the actual machine with the defined values
        _build_machine (machine, self.profile, name, devices, None, None, True)
        MachineManager.add(machinename, machine, name)

    def testBuildMachineDefinitionFormat3_NoOwner(self):
        """Core and build machine according to definition format creating tower"""
        machine = MachineManager.Machine ()
        pose = {"position":[-0,20,-0], "rotation": [1.0, 0.0, 0.0, 0.0]}
        name = "Tower inferno"
        self.profile["machines"] = {'Tower inferno': {'devices': [{'blueprint': {'mesh': 'cube.1m.mesh', 'description': 'A big tower', 'motor': '23', 'id': 1}, 'name': 'Tower 3H', 'resource_id': 46, 'pose': {'position': [0.0, 0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [{'blueprint': {'filter': ' ', 'mesh': 'cube.1m.mesh', 'view': ' ', 'description': 'A simple camera having 3 view and 3 filters', 'id': 1}, 'name': 'Camera F3V3', 'resource_id': 47, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 46, 'supports': [{'name': 'Weapon connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 8, 'quaternion_w': 1.0, 'description': 'A basic centered weapon connector'}], 'class': 'camera'}, {'blueprint': {'id': 16, 'mesh': 'cube.1m.mesh', 'locations': '10,50,90,160', 'description': 'Sensor with eight infrared distance sensors.'}, 'name': 'IR 8 1RM', 'resource_id': 48, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 47, 'supports': [{'name': 'Radio connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 3, 'quaternion_w': 1.0, 'description': 'A centered radio connector.'}, {'name': 'GPS connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 5, 'quaternion_w': 1.0, 'description': 'A simple GPS connector'}], 'class': 'ir'}], 'bolt': 45, 'supports': [{'name': 'IR Connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 2, 'quaternion_w': 1.0, 'description': 'A centered connector that allows a base device to add a infrared device.'}, {'name': 'Camera connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 4, 'quaternion_w': 1.0, 'description': 'A simple centered camera connector.'}], 'class': 'footing'}]}, 'robberto': {'devices': [{'blueprint': {'tire_front_id': 4, 'brake_front_id': 6, 'suspension_rear_id': 3, 'driveshaft_front_id': 13, 'id': 15, 'description': 'A 4x2 Terrain Vehicle that ', 'wheel_front_id': 9, 'brake_rear_id': 6, 'chassi_id': 1, 'steering_arm_id': 8, 'axle_front_id': 5, 'shockabsorber_front_id': 10, 'driveshaft_rear_id': 13, 'controlarm_front_id': 12, 'engine_id': 2, 'axle_rear_id': 5, 'tire_rear_id': 4, 'suspension_front_id': 3, 'steering_id': 9, 'shockabsorber_rear_id': 10, 'controlarm_rear_id': 12, 'wheel_rear_id': 9}, 'name': '4x2 Terrain Vehicle x1.2', 'resource_id': 26, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [{'blueprint': {'filter': ' ', 'mesh': 'cube.1m.mesh', 'view': ' ', 'description': 'A simple camera having 3 view and 3 filters', 'id': 1}, 'name': 'Camera F3V3', 'resource_id': 34, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 35, 'supports': [{'name': 'Weapon connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 8, 'quaternion_w': 1.0, 'description': 'A basic centered weapon connector'}], 'class': 'camera'}, {'blueprint': {'id': 16, 'mesh': 'cube.1m.mesh', 'locations': '10,50,90,160', 'description': 'Sensor with eight infrared distance sensors.'}, 'name': 'IR 8 1RM', 'resource_id': 35, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [{'blueprint': {'mesh': 'cube.1m.mesh', 'description': 'Simple radio having three basic services.', 'service': 'request reset;may-day stall', 'id': 1}, 'name': 'Radio S3', 'resource_id': 36, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 37, 'supports': [], 'class': 'radio'}, {'blueprint': {'mesh': 'cube.1m.mesh', 'description': 'Simple GPS system supporting 50 diameter update range.', 'id': 2}, 'name': 'GPS 50D', 'resource_id': 37, 'pose': {'position': [0.0, 2.0, 0.0], 'rotation': [1.0, 0.0, 0.0, 0.0]}, 'devices': [], 'bolt': 38, 'supports': [], 'class': 'gps'}], 'bolt': 36, 'supports': [{'name': 'Radio connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 3, 'quaternion_w': 1.0, 'description': 'A centered radio connector.'}, {'name': 'GPS connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 5, 'quaternion_w': 1.0, 'description': 'A simple GPS connector'}], 'class': 'ir'}], 'bolt': 34, 'supports': [{'name': 'IR Connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 2, 'quaternion_w': 1.0, 'description': 'A centered connector that allows a base device to add a infrared device.'}, {'name': 'Camera connector', 'quaternion_y': 0.0, 'quaternion_x': 0.0, 'quaternion_z': 0.0, 'position_z': 0.0, 'position_x': 0.0, 'position_y': 0.0, 'id': 4, 'quaternion_w': 1.0, 'description': 'A simple centered camera connector.'}], 'class': 'vehicle'}]}}
        devices = self.profile["machines"][name]['devices']
        machinename = self.profile["controler_key"]+name        
        #build the actual machine with the defined values
        _build_machine (machine, self.profile, name, devices, None, None, False)
        MachineManager.add(machinename, machine, name)
       
def __build_debug_world ():
    target = SceneManager.addEntity ("target","cube.1m.mesh")
    target.setScale (1,500,1000)
    target.setPosition (320, 100, 209) #(387.43, 0, 209)
    target.setMaterial("TransparentCell/Goal")
    #SystemHandler.addIntersectionDetection("target")
