"""
All the constants in the game interface.
"""
__author__ = "Kjartan A Jonsson"
__version__ = "$Revision: 1.2 $"
__copyright__ = "Copyright (c) 2007 aGameCompany"
__license__ = "aGameCompany"

#CONSTANT TIMER CALLBACK VALUES
CALLBACK_TIME_AI = 100

#SYSTEM EVENTS
SYSTEMEVENT_LOAD = 10        #called when system wants user to know that we are loading
SYSTEMEVENT_UNLOAD = 11      #called when system wants user to know that we are unloading

#GAME CALLBACKS
CONTROL_CALLBACK_KEYBOARD = 51001    #called to controller
CONTROL_CALLBACK_TIMER    = 51011   #timer callback trap used by the controlers
PATH_LOG = "" #"../../log"

#MENU CALLBACK 
MENU_CALLBACK_TIMER = 61000
MENU_CALLBACK_TIMER_ROOT = 61001
MENU_CALLBACK_KEYBOARD = 62000

WINDOW_POSTION_DELTA_HEIGHT = 10

#common constants
true = 1
false = 0

BTN_F1="F1"
BTN_F2="F2"
BTN_F3="F3"
BTN_F4="F4"
BTN_F5="F5"
BTN_F6="F6"
BTN_F7="F7"
BTN_F8="F8"
BTN_F9="F9"
BTN_F10="F10"
BTN_F11="F11"
BTN_F12="F12"
BTN_F13="F13"
BTN_F14="F14"
BTN_F15="F15"
BTN_1="1"
BTN_2="2"
BTN_3="3"
BTN_4="4"
BTN_5="5"
BTN_6="6"
BTN_7="7"
BTN_8="8"
BTN_9="9"
BTN_0="0"
BTN_A="A"
BTN_S="S"
BTN_D="D"
BTN_F="F"
BTN_G="G"
BTN_H="H"
BTN_J="J"
BTN_K="K"
BTN_L="L"
BTN_Z="Z"
BTN_X="X"
BTN_C="C"
BTN_V="V"
BTN_B="B"
BTN_N="N"
BTN_M="M"
BTN_Q="Q"
BTN_W="W"
BTN_E="E"
BTN_R="R"
BTN_T="T"
BTN_Y="Y"
BTN_U="U"
BTN_I="I"
BTN_O="O"
BTN_P="P"
BTN_ESCAPE="ESCAPE"
BTN_MINUS="MINUS"
BTN_EQUALS="EQUALS"
BTN_BACK="BACK"
BTN_TAB="TAB"
BTN_LBRACKET="LBRACKET"
BTN_RBRACKET="RBRACKET"
BTN_RETURN="RETURN"
BTN_LCONTROL="LCONTROL"
BTN_SEMICOLON="SEMICOLON"
BTN_APOSTROPHE="APOSTROPHE"
BTN_GRAVE="GRAVE"
BTN_LSHIFT="LSHIFT"
BTN_BACKSLASH="BACKSLASH"
BTN_COMMA="COMMA"
BTN_PERIOD="PERIOD"
BTN_SLASH="SLASH"
BTN_RSHIFT="RSHIFT"
BTN_MULTIPLY="MULTIPLY"
BTN_LMENU="LMENU"
BTN_SPACE="SPACE"
BTN_CAPITAL="CAPITAL"
BTN_NUMLOCK="NUMLOCK"
BTN_SCROLL="SCROLL"
BTN_NUMPAD7="NUMPAD7"
BTN_NUMPAD8="NUMPAD8"
BTN_NUMPAD9="NUMPAD9"
BTN_SUBTRACT="SUBTRACT"
BTN_NUMPAD4="NUMPAD4"
BTN_NUMPAD5="NUMPAD5"
BTN_NUMPAD6="NUMPAD6"
BTN_ADD="ADD"
BTN_NUMPAD1="NUMPAD1"
BTN_NUMPAD2="NUMPAD2"
BTN_NUMPAD3="NUMPAD3"
BTN_NUMPAD0="NUMPAD0"
BTN_DECIMAL="DECIMAL"
BTN_OEM_102="OEM_102"
BTN_KANA="KANA"
BTN_ABNT_C1="ABNT_C1"
BTN_CONVERT="CONVERT"
BTN_NOCONVERT="NOCONVERT"
BTN_YEN="YEN"
BTN_ABNT_C2="ABNT_C2"
BTN_NUMPADEQUALS="NUMPADEQUALS"
BTN_PREVTRACK="PREVTRACK"
BTN_AT="AT"
BTN_COLON="COLON"
BTN_UNDERLINE="UNDERLINE"
BTN_KANJI="KANJI"
BTN_STOP="STOP"
BTN_AX="AX"
BTN_UNLABELED="UNLABELED"
BTN_NEXTTRACK="NEXTTRACK"
BTN_NUMPADENTER="NUMPADENTER"
BTN_RCONTROL="RCONTROL"
BTN_MUTE="MUTE"
BTN_CALCULATOR="CALCULATOR"
BTN_PLAYPAUSE="PLAYPAUSE"
BTN_MEDIASTOP="MEDIASTOP"
BTN_VOLUMEDOWN="VOLUMEDOWN"
BTN_VOLUMEUP="VOLUMEUP"
BTN_WEBHOME="WEBHOME"
BTN_NUMPADCOMMA="NUMPADCOMMA"
BTN_DIVIDE="DIVIDE"
BTN_SYSRQ="SYSRQ"
BTN_RMENU="RMENU"
BTN_PAUSE="PAUSE"
BTN_HOME="HOME"
BTN_UP="UP"
BTN_PGUP="PGUP"
BTN_LEFT="LEFT"
BTN_RIGHT="RIGHT"
BTN_END="END"
BTN_DOWN="DOWN"
BTN_PGDOWN="PGDOWN"
BTN_INSERT="INSERT"
BTN_DELETE="DELETE"
BTN_LWIN="LWIN"
BTN_RWIN="RWIN"
BTN_APPS="APPS"
BTN_POWER="POWER"
BTN_SLEEP="SLEEP"
BTN_WAKE="WAKE"
BTN_WEBSEARCH="WEBSEARCH"
BTN_WEBFAVORITES="WEBFAVORITES"
BTN_WEBREFRESH="WEBREFRESH"
BTN_WEBSTOP="WEBSTOP"
BTN_WEBFORWARD="WEBFORWARD"
BTN_WEBBACK="WEBBACK"
BTN_MYCOMPUTER="MYCOMPUTER"
BTN_MAIL="MAIL"
BTN_MEDIASELECT="MEDIASELECT"

def toHTML (str) :
    #http://www.tntluoma.com/sidebars/codes/
    return str.replace("'", "&#39;").replace("\"", "&quot;").replace("\\", "&#47;").replace(",", "&#44;").replace("[", "&#91;").replace("]", "&#93;").replace("{", "&#123;").replace("}", "&#125;").replace("<", "&lt;").replace(">", "&gt;").replace("'", "&#39;")
