#####################################################
#    Drivers
#####################################################
import GUI
import SceneManager

class Device :
    """
    This is a driver interfaces that handles lower level management of container device.
    """
    machine_group = "container"
    device_type = "container"
    x = 0
    y = 0
    z = 0
    entity = None #the entity we use to do intersection testing
    __input_state = {"Name":None, "Gas":str( False ).lower(), "Brake":str( False ).lower(), "Left":str( False ).lower(), "Right":str( False ).lower()}
    __driver = None
    __sensored_cd = {} #is the sensors index from 0 to n
    __index = {} #is an index looking up sensor name and looking up the index
    __ignore = []
    
    def __init__(self, entity) : 
        print "container driver starting up"
        self.__ignore = []
        self.entity = entity

    def setDriver (self, d) : 
        """
        Called by the Driver when it was created
        """
        self.__driver = d

    class Driver:
        instance = None
        def __init__(self, dev, type = "Container"):
            pyrobot.robot.device.Device.__init__(self, type)
            self._dev = dev
        
def create () : 
    """First thing called"""
    print "Creating container"
    
def destroy () : 
    """Last thing called"""
    print "Destroying container"
    
def callback (trap, id, param) : 
    """
    Used by the system and systems other modules for communication
    Where trap can be:
        TRAP_SYSTEM: is called by system
    """
    print str(trap), str(id), param

def tests () :
    """
    Used to run internal tests checking the module
    Raises module.ModuleException
    """
    pass

def gui (position=[], visiable=None):
    """
    This is function is called when the module is started and shut down.
    It returns and sets gui specific information.
    This is to remember where the gui is at on reload. Returns a dictionary
        {position:[x,y], visiable:True/False}
    Is called before tests.
    """
    pass

