#####################################################
#    Drivers
#####################################################
import GUI
import SceneManager

class Device :
    """
    This is a driver interfaces that handles lower level management of tower device.
    """
    device_type = "robot"
    machine_group = "footing"
    x = 0
    y = 0
    z = 0
    entity = None #the entity we use to do intersection testing
    __driver = None
    
    def __init__(self, entity, entity_upper=None) : 
        print "container driver starting up"
        self.entity = entity
        if entity_upper <> None : self.entity = entity_upper

    def setDriver (self, d) : 
        """
        Called by the Driver when it was created
        """
        self.__driver = d

    def setVisible (self, b) : 
        pass #see other devices how this is managed

    def getInterface (self):
        """
        Returns device interface
        """
        return {"move": self.move, "motors": self.motor, "x": self.x, "y": self.y, "z": self.z, "getPosition":self.getPosition, "getRotation":self.getRotation, "th":self.getTh, "isStall":self.isStall }
    def getPosition (self) :
        p = self.entity.getPosition()
        if self.gui <> None : self.gui.setPosition(p[0], p[1], p[2])
        return p
    def getRotation(self):
        #r = self.__driver.getRotation() 
        #if self.gui <> None : self.gui.setRotation(r[0],r[1],r[2])
        return [0, 0, 0]#r
    def getTh(self):
        pass
        #th = self.__driver.getTh()
        #if self.gui <> None : self.gui.setTheta (th)
        return 0 #th
    def move(self, translation, rotation) :
        pass 
        #if self.gui <> None : self.gui.setMove (translation, rotation)
        #self.__driver.move(translation, rotation)
    def motor(self, left, right) :
        pass
        #if self.gui <> None : self.gui.setMotor (left, right)
        #self.__driver.motor(left, right)
        
    def isStall (self) : return False #the tower is always stall
    class Driver:
        instance = None
        def __init__(self, dev, type = "footing"):
            pyrobot.robot.device.Device.__init__(self, type)
            self._dev = dev
        
def create () : 
    """First thing called"""
    print "Creating tower"
    
def destroy () : 
    """Last thing called"""
    print "Destroying tower"
    
def callback (trap, id, param) : 
    """
    Used by the system and systems other modules for communication
    Where trap can be:
        TRAP_SYSTEM: is called by system
    """
    print "Tower:", str(trap), str(id), param

def tests () :
    """
    Used to run internal tests checking the module
    Raises module.ModuleException
    """
    pass

def gui (position=[], visiable=None):
    """
    This is function is called when the module is started and shut down.
    It returns and sets gui specific information.
    This is to remember where the gui is at on reload. Returns a dictionary
        {position:[x,y], visiable:True/False}
    Is called before tests.
    """
    pass

