"""
A Subsumption Behavior-based Brain
"""
#http://emergent.brynmawr.edu/emergent/PyroModuleBehaviorBasedControl
# A Behavior-based brain

from pyrobot.brain.fuzzy import *
from pyrobot.brain.behaviors import *

class StraightAhead(Behavior):
    def update(self):
        self.IF(0.4, 'translate', 0.25)
        self.IF(0.4, 'rotate',    0.0)

class Avoid(Behavior):
    def update(self):
        self.IF(0.2, 'translate', 0.0)
        self.IF(0.2, 'rotate',    -0.7)

class state1 (State):
    def setup(self):
        self.add(StraightAhead(1, {'translate': 0.3, 'rotate': 0.3}))
        self.add(Avoid(1,         {'translate': 0.3, 'rotate': 0.3}))

def INIT(engine): 
    brain = BehaviorBasedBrain({'translate' : engine.robot.translate, \
                                'rotate' : engine.robot.rotate, \
                                'update' : engine.robot.update }, engine)
    brain.add(state1(1)) 
    return brain