"""
Robot goes forward and then slows and backup up when it detects something 
"""
from pyrobot.geometry import *   # import distance function
from pyrobot.brain.behaviors import State, FSMBrain

class avoid (State):

    steps = 0

    def onActivate(self): # method called when activated or gotoed
        self.maxvalue = self.robot.range.getMaxvalue()
        self.steps = 0
        
    def determineTargets(self, left, front, right):
        if front < 1.0:
            #print "front"
            return([0.0, 0.5])
        elif left < 1.0:
            #print "left"
            return([0.5, -0.5])
        elif right < 1.0:
            #print "right"
            return([0.5, 0.5])
        else:
            #print "clear"
            self.steps = self.steps + 1
            return([0.3, 0.0])
    # Scale the range readings to be between 0 and 1.  Also make close 
    # obstacles register high readings, and distance obstacles low readings. 
    def scale(self, val):
        return (1 - (val / self.maxvalue))        
    def step(self):
        left  = min([s.distance() for s in self.robot.range["front-left"]])
        front = min([s.distance() for s in self.robot.range["front"]])
        right = min([s.distance() for s in self.robot.range["front-right"]])
        trnTarget,rotTarget = self.determineTargets(left, front, right)
        self.robot.move(trnTarget*1.0, rotTarget*2.0)
        if self.steps > 14 : self.goto('movetowards')

class movetowards (State):
    #trg = [-434,-500] #-434,-600
    trg = -434,-600
    src = [0,0]
    radius = 10
    
    def collision (self):
        front = min([s.distance() for s in self.robot.range["front"]])
        if front < 1.0 : return True
        return False
    
    def inrange (self):
        """
        Checks if src is within 500 radius of trg
        """
        if self.src[0] < (self.trg[0] + self.radius) :
            if self.src[0] > (self.trg[0] - self.radius) :
                if self.src[1] < (self.trg[1] + self.radius) :                     
                    if self.src[1] > (self.trg[1] - self.radius) : 
                        return True
        return False
    
    def updateSource (self):
        self.src[0] = self.robot.x
        self.src[1] = self.robot.y
        self.th = self.robot.th
         
    def onActivate(self):
        self.src = [0,0]
        self.state = "rotation"

    def step(self):
        self.updateSource()
        th = math.degrees(math.atan2(self.src[0]-self.trg[0],self.src[1]-self.trg[1]))
        delta_th = th-self.th
        if delta_th < -180 : delta_th = 360 + delta_th
        elif delta_th > 180 : delta_th = delta_th - 360          
        change_th = abs(delta_th)
        #print "TURN: now = %f adjust = %f" % (th, delta_th)
        if self.collision () :
            self.goto('avoid')
        elif self.inrange () :
            #print "WE FOUND IT!!!!!!!!!!!!!!!!!!!!!!" + str(self.src)
            self.robot.move (0, 0)
        elif change_th < 5 : 
            self.state = "drive"
            self.robot.move (1, 0)
        elif change_th > 45 :
            self.state = "rotation"
            self.robot.move (0, delta_th)
        else :
            self.state = "rotation"
            self.robot.move (1, delta_th)

def INIT(engine):
    brain = FSMBrain(engine=engine)
    # add a few states:
    brain.add(avoid(0)) # 1 makes it active
    brain.add(movetowards(1))
    return brain