import GUI
import pyrobot.robot.device

class DeviceRadioException (Exception) : pass

class Device :
    """
    """
    __driver = None
    machine_group = "communication"
    device_type = "weapon"    
    gui = None
    
    def __init__(self, entity):
        self.entity = entity
        
    def setDriver (self, d) : 
        """
        Called by the Driver when it was created
        """
        self.__driver = d
        self.__driver.setEntity (self.entity)        

    def getDriver (self) : return self.__driver  
        
    def setVisible (self, b) : 
        """This is called when we are un-selecting and selecting the machine"""
        self.__driver.setVisible(b)
        self.gui = self.__driver.gui

    def getGUI (self) : return self.__driver.getGUI()
                    
    class Driver(pyrobot.robot.device.Device): 
        
        gui = None
        __gui_instance = None #holds the original gui instance
        
        def __init__(self, dev, type = "radio") :
            pyrobot.robot.device.Device.__init__(self, type)
            self._dev = dev            
            self.entity = None
            self.__gui_instance = DeviceWindow(self)
        
        def setEntity (self, entity) :
            """Sets the entity so that we can control it"""
            self.entity = entity
            
        def setVisible (self, b) : 
            """This is called when we are un-selecting and selecting the machine"""
            if b : 
                self.gui = self.__gui_instance
            else :
                self.gui = None
    
        def getGUI (self) : return self.__gui_instance

from window import Window #get base menu class
class DeviceWindow (Window) :
    """Handles camera menu"""
    __driver = None
    
    def __init__ (self, driver):
    	import const
        self.__driver = driver
        self.log_attempt ("register Radio interface")
#        try :
#            pass 
#            GUI.systemGUI.loadLayout ("radio.swf", 256, 256)
#            GUI.systemGUI.setPosition("radio.swf", 0, const.WINDOW_POSTION_DELTA_HEIGHT*2)
#            GUI.systemGUI.addEventSubscriber ("radio.swf", "executeService", "receaveMenuEvent", "execute event")
#            GUI.systemGUI.call ("radio.swf", "clearLists", " ")
#            services = self.__driver.getServices()
#            for service in services : 
#    	           GUI.systemGUI.call ("radio.swf", "addService", service)
#        except Exception, e: self.log_failure (False, str(e))
        self.log_success ()
        
    def clear (self):
        pass #GUI.systemGUI.delLayout ("radio.swf")

    def callback (self, source, event, message):
    	arg = eval(message)
        if event == "executeService" : 
            pass #self.__driver.callService(arg["arguments"][0])    
    
import SceneManager
import MachineManager
import __vehiclemanager as vehiclemanager
import unittest
import rover

class TestDevice(unittest.TestCase):
    entity = None

    def setUp(self):
        import xmlrpclib
        import settings
        __rpc_state = xmlrpclib.ServerProxy( settings.SERV_STATE_ENTITY, transport=settings.proxy )
        profile = __rpc_state.login( "unittest", "unittest" )

        self.machine = MachineManager.Machine()
        self.machine.name = "MyMachine.w.radio"
        self.machine.id = "MyMachine.w.radio_id"
        MachineManager.add (self.machine.id, self.machine, self.machine.name)

        self.rover = vehiclemanager.getStaticVehicle (profile["account_key"], "4x2 Terrain Rover x1.2", "robbie")
        self.roverdev = rover.Device (self.rover)
        self.machine.addDevice("robbie", self.roverdev)
        
        self.entity = SceneManager.addEntity ("radiodevicetest", "cube.1m.mesh")
        self.radiodev = Device (self.entity, self.machine.id)
        self.radiodev.setDriver(Device.Driver(None))
        self.machine.addDevice ("radiodevicetest", self.radiodev)

    def tearDown(self):
        self.radiodev.setVisible(False)
        self.radiodev.getGUI().clear()
        self.rover.destroy()
        SceneManager.delEntity ("radiodevicetest")

    def testGUIActivate(self):
        """Radio device and test GUI active and unactive"""
        self.radiodev.setVisible(True)
        self.radiodev.setVisible(True)
