import GUI
import SystemHandler
import const

LOG_MESSAGE = 0
LOG_WARNING = 1
LOG_ERROR = 2
LOG_FAULT = 3

def log (str, type=0, newline=True):
    """Will write str into log"""
    pre = ""
    if type == LOG_WARNING : 
        pre = "Warning:"
    elif type == LOG_ERROR : 
        pre = "Error :"
    elif type == LOG_FAULT : 
        pre = "Fault :"                
    trg = "Root/Background/lblLog"
    #log = GUI.systemGUI.getText (trg)
    #log = log + pre + str
    #if newline : log = log + "\\r"
    #GUI.systemGUI.setText (trg, log)

def log_message (message, newline=True) :
    log (message, 0, newline)

def log_attempt (msg):
    """
    Will log an attempt message then call log_progress()
    Follow through by calling log_success() or log_failure()
    """
    log (msg+" ", LOG_MESSAGE, newline=False)

def log_progress ():
    log (".", LOG_MESSAGE, newline=False)

def log_success (with_progress=True, message=""):
    """
    Will log an attempt message
    Follow through by calling log_success() or log_failure()
    """
    if message <> "" : message = " ("+ message + ")"
    if with_progress : log ("... DONE"+message, LOG_MESSAGE)
    else : log (" DONE"+message, LOG_MESSAGE)

def log_failure(with_progress=True, message=""):
    """
    Will log an attempt message
    Follow through by calling log_success() or log_failure()
    """
    if message <> "" : message = " ("+ message + ")"
    if with_progress : log ("... FAILURE" + message, LOG_MESSAGE)
    else : log (" FAILURE" + message, LOG_MESSAGE)


class Window :
    __wnd = None
    def log_failure(self, with_progress=True, message=""): log_failure(with_progress, message)
    def log_message(self, message=""): log_message (message)
    def log_success (self, with_progress=True, message=""): log_success (with_progress, message)
    def log_progress (self): log_progress()
    def log_attempt (self, msg): log_attempt(msg)
    def log (self, str, type=0, newline=True): log(str, type, newline)          
    def callback (self, source, event, message) : log ("No call-back override for current menu", LOG_ERROR)
    def callnext (self, message, t=100): SystemHandler.timerCallBack(t, const.MENU_CALLBACK_TIMER, message)        
    def load_windows (self):
        """will load all the device windows setup"""
        pass
#        if self.__wnd == None : 
#            self.__wnd = {}
#        for w in self.__wnd : self.__load_window( w, self.__wnd[w]["x"], self.__wnd[w]["y"], self.__wnd[w]["w"], self.__wnd[w]["h"])
    def save_windows (self):
        """will save the device window setup"""
        pass
#        self.log_message("Start - Saving all the windows")
#        if self.__wnd == None : 
#            self.__wnd = {}
#            self.log_message("None - Saving all the windows")
#        for w in self.__wnd : 
#            self.log_message("x - Saving all the windows " + w)
#            self.__save_window( w )
#        self.log_message("Saving all the windows" + str(self.__wnd) )
    def place_window (self, name):
        """will register the window"""
        pass
#        if self.__wnd == None : 
#            self.__wnd = {}
#        self.log_message("Registering window " + name, False)
#        if not self.__wnd.has_key(name) :
#            self.__wnd[name] = {"x":0, "y":0, "w":0, "h":0} 
#        #else : 
#            #p = self.__wnd[name]
#            #self.__load_window (name, p["x"], p["y"], p["w"], p["h"])
    def __load_window (self, windowname, x, y, w, h):
        """will load the device window setup"""
        pass
#        GUI.systemGUI.setProperty (windowname, "UnifiedXPosition", "{"+str(x)+"}")
#        GUI.systemGUI.setProperty (windowname, "UnifiedYPosition", "{"+str(y)+"}")
#        GUI.systemGUI.setProperty (windowname, "UnifiedWidth", "{"+str(w)+",0}")
#        GUI.systemGUI.setProperty (windowname, "UnifiedHeight", "{"+str(h)+",0}")
    def __save_window (self, windowname):
        """will save the device window setup"""
        pass
#        self.log_message("saving " + windowname)
#        try :
#            self.__wnd[windowname]["x"] = GUI.systemGUI.getProperty (windowname, "UnifiedXPosition")
#            self.__wnd[windowname]["y"] = GUI.systemGUI.getProperty (windowname, "UnifiedYPosition")
#            self.__wnd[windowname]["w"] = GUI.systemGUI.getProperty (windowname, "UnifiedWidth")
#            self.__wnd[windowname]["h"] = GUI.systemGUI.getProperty (windowname, "UnifiedHeight")
#        except Exception, e : self.log_failure (False, "Could not save window " + str(e))
